/*
 * Copyright (c) Institute for System Programming of the Russian Academy of Sciences
 * All Rights Reserved
 *
 * Institute for System Programming of the Russian Academy of Sciences (ISP RAS)
 * 25 Alexander Solzhenitsyn st., Moscow, 109004, Russia
 * http://www.ispras.ru
 *
 * The present file was automatically generated on the basis of formal specifications.
 * It is distributed under the same terms and conditions as the derived specifications.
 *
 * N.B. PLEASE DO NOT MODIFY THIS FILE.
 */

package ru.ispras.microtesk.model.cpu;

import java.math.BigInteger;
import ru.ispras.microtesk.model.api.PEState;
import ru.ispras.microtesk.model.api.data.Type;
import ru.ispras.microtesk.model.api.memory.Label;
import ru.ispras.microtesk.model.api.memory.Memory;

/**
 * The {@code PE} class is automatically generated by MicroTESK.
 *
 * @author <a href="mailto:microtesk-support@ispras.ru">MicroTESK</a>
 */
public final class PE extends PEState {
  public final Memory GPR;
  public final Memory PC;
  public final Memory M;
  public final Memory SRC1;
  public final Memory SRC2;
  public final Memory DEST;

  public PE() {
    this.GPR = Memory.def(Memory.Kind.REG, "GPR", TypeDefs.BYTE, 0x10);
    this.PC = Memory.def(Memory.Kind.REG, "PC", TypeDefs.INDEX, 0x1);
    this.M = Memory.def(Memory.Kind.MEM, "M", TypeDefs.BYTE, 0x100);
    this.SRC1 = Memory.def(Memory.Kind.VAR, "SRC1", TypeDefs.BYTE, 0x1);
    this.SRC2 = Memory.def(Memory.Kind.VAR, "SRC2", TypeDefs.BYTE, 0x1);
    this.DEST = Memory.def(Memory.Kind.VAR, "DEST", TypeDefs.BYTE, 0x1);

    registerAll();
  }

  public PE(final PE other) {
    this.GPR = other.GPR;
    this.PC = other.PC;
    this.M = other.M;
    this.SRC1 = other.SRC1;
    this.SRC2 = other.SRC2;
    this.DEST = other.DEST;

    registerAll();
  }

  private void registerAll() {
    addStorage(GPR);
    addStorage(PC);
    addStorage(M);
    addStorage(SRC1);
    addStorage(SRC2);
    addStorage(DEST);
  }
}
