/*
 * Copyright (c) Institute for System Programming of the Russian Academy of Sciences
 * All Rights Reserved
 *
 * Institute for System Programming of the Russian Academy of Sciences (ISP RAS)
 * 25 Alexander Solzhenitsyn st., Moscow, 109004, Russia
 * http://www.ispras.ru
 *
 * The present file was automatically generated on the basis of formal specifications.
 * It is distributed under the same terms and conditions as the derived specifications.
 *
 * N.B. PLEASE DO NOT MODIFY THIS FILE.
 */

package ru.ispras.microtesk.model.cpu.mode;

import java.util.Map;
import java.math.BigInteger;
import ru.ispras.microtesk.model.api.Execution;
import ru.ispras.microtesk.model.api.PEState;
import ru.ispras.microtesk.model.api.data.*;
import ru.ispras.microtesk.model.api.instruction.*;
import ru.ispras.microtesk.model.api.memory.Location;
import ru.ispras.microtesk.model.cpu.PE;

import static ru.ispras.microtesk.model.cpu.TypeDefs.*;

public final class IMM extends AddressingMode {
  public static final String NAME = "IMM";

  private static final class Info extends InfoAndRule {
    Info() {
      super(
          IMM.class,
          "IMM",
          BYTE,
          new ArgumentDecls()
              .add("i", BYTE)
      );
    }

    @Override
    public AddressingMode create(final Map<String, Primitive> args) {
      final Immediate i = (Immediate) getArgument("i", args);
      return new IMM(i);
    }
  }

  public static final IInfo INFO = new Info();

  public final Immediate i;

  public IMM(final Immediate i) {
    this.i = i;
  }

  @Override
  public String syntax(final PEState peState) {
    final PE pe__ = (PE) peState;
    return String.format("[%d]", i.access(pe__).load().bigIntegerValue());
  }

  @Override
  public String image(final PEState peState) {
    final PE pe__ = (PE) peState;
    return String.format("11%4b", i.access(pe__).load().toBinString());
  }

  @Override
  public Location access(final PEState peState) {
    final PE pe__ = (PE) peState;
    return i.access(pe__).setName(syntax(pe__));
  }
}