/*
 * Copyright (c) Institute for System Programming of the Russian Academy of Sciences
 * All Rights Reserved
 *
 * Institute for System Programming of the Russian Academy of Sciences (ISP RAS)
 * 25 Alexander Solzhenitsyn st., Moscow, 109004, Russia
 * http://www.ispras.ru
 *
 * The present file was automatically generated on the basis of formal specifications.
 * It is distributed under the same terms and conditions as the derived specifications.
 *
 * N.B. PLEASE DO NOT MODIFY THIS FILE.
 */

package ru.ispras.microtesk.model.minimips.op;

import java.util.Map;
import java.math.BigInteger;
import ru.ispras.microtesk.model.api.ArgumentMode;
import ru.ispras.microtesk.model.api.Execution;
import ru.ispras.microtesk.model.api.PEState;
import ru.ispras.microtesk.model.api.data.*;
import ru.ispras.microtesk.model.api.memory.*;
import ru.ispras.microtesk.model.api.instruction.*;
import ru.ispras.microtesk.model.minimips.PE;
import ru.ispras.microtesk.model.minimips.mode.*;
import ru.ispras.microtesk.model.api.memory.Location;

import static ru.ispras.microtesk.model.minimips.TypeDefs.*;

public final class addi extends Operation {
  private static final class Info extends InfoAndRule {
    Info() {
      super(
         addi.class,
         "addi",
         new ArgumentDecls()
             .add("rt", REG.INFO)
             .add("rs", REG.INFO)
             .add("imm", SHORT),
         new Shortcuts()
             .addShortcut(new Info_instruction(), "#root")
      );
    }

    @Override
    public Operation create(final Map<String, Primitive> args) {
      final REG rt = (REG) getArgument("rt", args);
      final REG rs = (REG) getArgument("rs", args);
      final Immediate imm = (Immediate) getArgument("imm", args);

      return new addi(rt, rs, imm);
    }
  }
  private static final class Info_instruction extends InfoAndRule {
    Info_instruction() {
      super(
          instruction.class,
          "addi",
          new ArgumentDecls()
              .add("rt", REG.INFO)
              .add("rs", REG.INFO)
              .add("imm", SHORT)
      );
    }

    @Override
    public Operation create(final Map<String, Primitive> args) {
      final REG rt = (REG) getArgument("rt", args);
      final REG rs = (REG) getArgument("rs", args);
      final Immediate imm = (Immediate) getArgument("imm", args);

      return new instruction(
        new addi(
          rt,
          rs,
          imm
        )
      );
    }
  }
  public static final IInfo INFO = new Info();

  public final REG rt;
  public final REG rs;
  public final Immediate imm;

  public addi(final REG rt, final REG rs, final Immediate imm) {
    assert REG.INFO.isSupported(rt);
    assert REG.INFO.isSupported(rs);
    assert SHORT.equals(imm.getType());
    this.rt = rt;
    this.rs = rs;
    this.imm = imm;
  }

  @Override
  public String syntax(final PEState peState) {
    final PE pe__ = (PE) peState;
    return String.format("addi %s, %s, 0x%x", rt.syntax(peState), rs.syntax(peState), imm.access(pe__).load().bigIntegerValue(false));
  }

  @Override
  public String image(final PEState peState) {
    final PE pe__ = (PE) peState;
    return String.format("000000%s%s%s", rs.image(peState), rt.image(peState), imm.access(pe__).load().toString());
  }

  @Override
  public void action(final PEState peState) {
    final PE pe__ = (PE) peState;
    pe__.temp.access().store(Location.concat(rs.access(pe__), rs.access(pe__).bitField(31, 31)).load().add(Data.signExtend(Type.INT(33), imm.access(pe__).load())));
    if (!pe__.temp.access().bitField(32, 32).load().equals(pe__.temp.access().bitField(31, 31).load())) {
      Execution.mark("overflow");
      pe__.COP0_R.access(14).store(pe__.CIA.access().load());
      Execution.exception("IntegerOverflow");
    } else {
      Execution.mark("normal");
      rt.access(pe__).store(pe__.temp.access().bitField(31, 0).load());
    }
  }
}