/*
 * Copyright (c) Institute for System Programming of the Russian Academy of Sciences
 * All Rights Reserved
 *
 * Institute for System Programming of the Russian Academy of Sciences (ISP RAS)
 * 25 Alexander Solzhenitsyn st., Moscow, 109004, Russia
 * http://www.ispras.ru
 *
 * The present file was automatically generated on the basis of formal specifications.
 * It is distributed under the same terms and conditions as the derived specifications.
 *
 * N.B. PLEASE DO NOT MODIFY THIS FILE.
 */

package ru.ispras.microtesk.model.minimips.op;

import java.util.Map;
import java.math.BigInteger;
import ru.ispras.microtesk.model.api.ArgumentMode;
import ru.ispras.microtesk.model.api.Execution;
import ru.ispras.microtesk.model.api.PEState;
import ru.ispras.microtesk.model.api.data.*;
import ru.ispras.microtesk.model.api.memory.*;
import ru.ispras.microtesk.model.api.instruction.*;
import ru.ispras.microtesk.model.minimips.PE;
import ru.ispras.microtesk.model.minimips.mode.*;
import ru.ispras.microtesk.model.api.memory.Location;

import static ru.ispras.microtesk.model.minimips.TypeDefs.*;

public final class bgez extends Operation {
  private static final class Info extends InfoAndRule {
    Info() {
      super(
         bgez.class,
         "bgez",
         new ArgumentDecls()
             .add("rs", REG.INFO)
             .add("offset", SHORT),
         new Shortcuts()
             .addShortcut(new Info_instruction(), "#root")
      );
    }

    @Override
    public Operation create(final Map<String, Primitive> args) {
      final REG rs = (REG) getArgument("rs", args);
      final Immediate offset = (Immediate) getArgument("offset", args);

      return new bgez(rs, offset);
    }
  }
  private static final class Info_instruction extends InfoAndRule {
    Info_instruction() {
      super(
          instruction.class,
          "bgez",
          new ArgumentDecls()
              .add("rs", REG.INFO)
              .add("offset", SHORT)
      );
    }

    @Override
    public Operation create(final Map<String, Primitive> args) {
      final REG rs = (REG) getArgument("rs", args);
      final Immediate offset = (Immediate) getArgument("offset", args);

      return new instruction(
        new bgez(
          rs,
          offset
        )
      );
    }
  }
  public static final IInfo INFO = new Info();

  public final REG rs;
  public final Immediate offset;

  public bgez(final REG rs, final Immediate offset) {
    assert REG.INFO.isSupported(rs);
    assert SHORT.equals(offset.getType());
    this.rs = rs;
    this.offset = offset;
  }

  @Override
  public String syntax(final PEState peState) {
    final PE pe__ = (PE) peState;
    return String.format("bgez %s, <label>%d", rs.syntax(peState), offset.access(pe__).load().bigIntegerValue());
  }

  @Override
  public String image(final PEState peState) {
    final PE pe__ = (PE) peState;
    return String.format("000001%s00001%s", rs.image(peState), offset.access(pe__).load().toString());
  }

  @Override
  public void action(final PEState peState) {
    final PE pe__ = (PE) peState;
    if ((rs.access(pe__).load().compareTo(Data.valueOf(WORD, 0x0)) >= 0)) {
      pe__.BRANCH.access().store(Data.valueOf(BIT, 0x1));
      pe__.JMPADDR.access().store(pe__.CIA.access().load().add(Data.valueOf(WORD, 0x4)).add(Data.signExtend(WORD, offset.access(pe__).load()).shiftLeft(Data.valueOf(WORD, 0x2))));
    }
  }
}