/*
 * Copyright (c) Institute for System Programming of the Russian Academy of Sciences
 * All Rights Reserved
 *
 * Institute for System Programming of the Russian Academy of Sciences (ISP RAS)
 * 25 Alexander Solzhenitsyn st., Moscow, 109004, Russia
 * http://www.ispras.ru
 *
 * The present file was automatically generated on the basis of formal specifications.
 * It is distributed under the same terms and conditions as the derived specifications.
 *
 * N.B. PLEASE DO NOT MODIFY THIS FILE.
 */

package ru.ispras.microtesk.model.minimips.op;

import java.util.Map;
import java.math.BigInteger;
import ru.ispras.microtesk.model.api.ArgumentMode;
import ru.ispras.microtesk.model.api.Execution;
import ru.ispras.microtesk.model.api.PEState;
import ru.ispras.microtesk.model.api.data.*;
import ru.ispras.microtesk.model.api.memory.*;
import ru.ispras.microtesk.model.api.instruction.*;
import ru.ispras.microtesk.model.minimips.PE;

import static ru.ispras.microtesk.model.minimips.TypeDefs.*;

public final class instruction extends Operation {
  private static final class Info extends InfoAndRule {
    Info() {
      super(
         instruction.class,
         "instruction",
         new ArgumentDecls()
             .add("command", Operations.INFO));
    }

    @Override
    public Operation create(final Map<String, Primitive> args) {
      final Operation command = (Operation) getArgument("command", args);

      return new instruction(command);
    }
  }
  public static final IInfo INFO = new Info();

  public final Operation command;

  public instruction(final Operation command) {
    assert Operations.INFO.isSupported(command);
    this.command = command;
  }

  @Override
  public String syntax(final PEState peState) {
    final PE pe__ = (PE) peState;
    return command.syntax(pe__);
  }

  @Override
  public String image(final PEState peState) {
    final PE pe__ = (PE) peState;
    return command.image(pe__);
  }

  @Override
  public void action(final PEState peState) {
    final PE pe__ = (PE) peState;
    pe__.GPR.access(0).store(Data.valueOf(WORD, 0x0));
    pe__.is_delay_slot.access().store(pe__.BRANCH.access().load());
    pe__.jump_address.access().store(pe__.JMPADDR.access().load());
    pe__.BRANCH.access().store(Data.valueOf(BIT, 0x0));
    pe__.JMPADDR.access().store(Data.valueOf(WORD, 0x0));
    command.execute(pe__);
    if (pe__.is_delay_slot.access().load().equals(Data.valueOf(BIT, 0x1)) && pe__.BRANCH.access().load().equals(Data.valueOf(BIT, 0x1))) {
      Execution.unpredicted();
    }
    if (pe__.is_delay_slot.access().load().equals(Data.valueOf(BIT, 0x1))) {
      pe__.CIA.access().store(pe__.jump_address.access().load());
    } else {
      pe__.CIA.access().store(pe__.CIA.access().load().add(Data.valueOf(WORD, 0x4)));
    }
  }
}