/*
 * Copyright (c) Institute for System Programming of the Russian Academy of Sciences
 * All Rights Reserved
 *
 * Institute for System Programming of the Russian Academy of Sciences (ISP RAS)
 * 25 Alexander Solzhenitsyn st., Moscow, 109004, Russia
 * http://www.ispras.ru
 *
 * The present file was automatically generated on the basis of formal specifications.
 * It is distributed under the same terms and conditions as the derived specifications.
 *
 * N.B. PLEASE DO NOT MODIFY THIS FILE.
 */

package ru.ispras.microtesk.model.minimips.op;

import java.util.Map;
import java.math.BigInteger;
import ru.ispras.microtesk.model.api.ArgumentMode;
import ru.ispras.microtesk.model.api.Execution;
import ru.ispras.microtesk.model.api.PEState;
import ru.ispras.microtesk.model.api.data.*;
import ru.ispras.microtesk.model.api.memory.*;
import ru.ispras.microtesk.model.api.instruction.*;
import ru.ispras.microtesk.model.minimips.PE;
import ru.ispras.microtesk.model.api.memory.Location;

import static ru.ispras.microtesk.model.minimips.TypeDefs.*;

public final class j extends Operation {
  private static final class Info extends InfoAndRule {
    Info() {
      super(
         j.class,
         "j",
         new ArgumentDecls()
             .add("addr", JUMP_IMM),
         new Shortcuts()
             .addShortcut(new Info_instruction(), "#root")
      );
    }

    @Override
    public Operation create(final Map<String, Primitive> args) {
      final Immediate addr = (Immediate) getArgument("addr", args);

      return new j(addr);
    }
  }
  private static final class Info_instruction extends InfoAndRule {
    Info_instruction() {
      super(
          instruction.class,
          "j",
          new ArgumentDecls()
              .add("addr", JUMP_IMM)
      );
    }

    @Override
    public Operation create(final Map<String, Primitive> args) {
      final Immediate addr = (Immediate) getArgument("addr", args);

      return new instruction(
        new j(
          addr
        )
      );
    }
  }
  public static final IInfo INFO = new Info();

  public final Immediate addr;

  public j(final Immediate addr) {
    assert JUMP_IMM.equals(addr.getType());
    this.addr = addr;
  }

  @Override
  public String syntax(final PEState peState) {
    final PE pe__ = (PE) peState;
    return String.format("j <label>%d", addr.access(pe__).load().bigIntegerValue());
  }

  @Override
  public String image(final PEState peState) {
    final PE pe__ = (PE) peState;
    return String.format("000010%s", addr.access(pe__).load().toString());
  }

  @Override
  public void action(final PEState peState) {
    final PE pe__ = (PE) peState;
    pe__.nia.access().store(pe__.CIA.access().load().add(Data.valueOf(WORD, 0x4)));
    pe__.temp_jump.access().store(Data.zeroExtend(Type.CARD(28), addr.access(pe__).load()).shiftLeft(Data.valueOf(Type.CARD(28), 0x2)));
    pe__.BRANCH.access().store(Data.valueOf(BIT, 0x1));
    pe__.JMPADDR.access().store(Location.concat(pe__.temp_jump.access(), pe__.nia.access().bitField(31, 28)).load());
  }
}