/*
 * Copyright (c) Institute for System Programming of the Russian Academy of Sciences
 * All Rights Reserved
 *
 * Institute for System Programming of the Russian Academy of Sciences (ISP RAS)
 * 25 Alexander Solzhenitsyn st., Moscow, 109004, Russia
 * http://www.ispras.ru
 *
 * The present file was automatically generated on the basis of formal specifications.
 * It is distributed under the same terms and conditions as the derived specifications.
 *
 * N.B. PLEASE DO NOT MODIFY THIS FILE.
 */

package ru.ispras.microtesk.model.minimips.op;

import java.util.Map;
import java.math.BigInteger;
import ru.ispras.microtesk.model.api.ArgumentMode;
import ru.ispras.microtesk.model.api.Execution;
import ru.ispras.microtesk.model.api.PEState;
import ru.ispras.microtesk.model.api.data.*;
import ru.ispras.microtesk.model.api.memory.*;
import ru.ispras.microtesk.model.api.instruction.*;
import ru.ispras.microtesk.model.minimips.PE;
import ru.ispras.microtesk.model.minimips.mode.*;

import static ru.ispras.microtesk.model.minimips.TypeDefs.*;

public final class jalr extends Operation {
  private static final class Info extends InfoAndRule {
    Info() {
      super(
         jalr.class,
         "jalr",
         new ArgumentDecls()
             .add("rd", REG.INFO)
             .add("rs", REG.INFO),
         new Shortcuts()
             .addShortcut(new Info_instruction(), "#root")
      );
    }

    @Override
    public Operation create(final Map<String, Primitive> args) {
      final REG rd = (REG) getArgument("rd", args);
      final REG rs = (REG) getArgument("rs", args);

      return new jalr(rd, rs);
    }
  }
  private static final class Info_instruction extends InfoAndRule {
    Info_instruction() {
      super(
          instruction.class,
          "jalr",
          new ArgumentDecls()
              .add("rd", REG.INFO)
              .add("rs", REG.INFO)
      );
    }

    @Override
    public Operation create(final Map<String, Primitive> args) {
      final REG rd = (REG) getArgument("rd", args);
      final REG rs = (REG) getArgument("rs", args);

      return new instruction(
        new jalr(
          rd,
          rs
        )
      );
    }
  }
  public static final IInfo INFO = new Info();

  public final REG rd;
  public final REG rs;

  public jalr(final REG rd, final REG rs) {
    assert REG.INFO.isSupported(rd);
    assert REG.INFO.isSupported(rs);
    this.rd = rd;
    this.rs = rs;
  }

  @Override
  public String syntax(final PEState peState) {
    final PE pe__ = (PE) peState;
    return String.format("jalr %s, %s", rs.syntax(peState), rd.syntax(peState));
  }

  @Override
  public String image(final PEState peState) {
    final PE pe__ = (PE) peState;
    return String.format("000000%s00000%s00000001001", rs.image(peState), rd.image(peState));
  }

  @Override
  public void action(final PEState peState) {
    final PE pe__ = (PE) peState;
    rd.access(pe__).store(pe__.CIA.access().load().add(Data.valueOf(WORD, 0x4)).add(Data.valueOf(WORD, 0x4)));
    pe__.BRANCH.access().store(Data.valueOf(BIT, 0x1));
    pe__.JMPADDR.access().store(rs.access(pe__).load());
  }
}