/*
 * Copyright (c) Institute for System Programming of the Russian Academy of Sciences
 * All Rights Reserved
 *
 * Institute for System Programming of the Russian Academy of Sciences (ISP RAS)
 * 25 Alexander Solzhenitsyn st., Moscow, 109004, Russia
 * http://www.ispras.ru
 *
 * The present file was automatically generated on the basis of formal specifications.
 * It is distributed under the same terms and conditions as the derived specifications.
 *
 * N.B. PLEASE DO NOT MODIFY THIS FILE.
 */

package ru.ispras.microtesk.model.minimips.op;

import java.util.Map;
import java.math.BigInteger;
import ru.ispras.microtesk.model.api.ArgumentMode;
import ru.ispras.microtesk.model.api.Execution;
import ru.ispras.microtesk.model.api.PEState;
import ru.ispras.microtesk.model.api.data.*;
import ru.ispras.microtesk.model.api.memory.*;
import ru.ispras.microtesk.model.api.instruction.*;
import ru.ispras.microtesk.model.minimips.PE;
import ru.ispras.microtesk.model.minimips.mode.*;

import static ru.ispras.microtesk.model.minimips.TypeDefs.*;

public final class mfc0 extends Operation {
  private static final class Info extends InfoAndRule {
    Info() {
      super(
         mfc0.class,
         "mfc0",
         new ArgumentDecls()
             .add("rt", REG.INFO)
             .add("cs", RCOP0.INFO),
         new Shortcuts()
             .addShortcut(new Info_instruction(), "#root")
      );
    }

    @Override
    public Operation create(final Map<String, Primitive> args) {
      final REG rt = (REG) getArgument("rt", args);
      final RCOP0 cs = (RCOP0) getArgument("cs", args);

      return new mfc0(rt, cs);
    }
  }
  private static final class Info_instruction extends InfoAndRule {
    Info_instruction() {
      super(
          instruction.class,
          "mfc0",
          new ArgumentDecls()
              .add("rt", REG.INFO)
              .add("cs", RCOP0.INFO)
      );
    }

    @Override
    public Operation create(final Map<String, Primitive> args) {
      final REG rt = (REG) getArgument("rt", args);
      final RCOP0 cs = (RCOP0) getArgument("cs", args);

      return new instruction(
        new mfc0(
          rt,
          cs
        )
      );
    }
  }
  public static final IInfo INFO = new Info();

  public final REG rt;
  public final RCOP0 cs;

  public mfc0(final REG rt, final RCOP0 cs) {
    assert REG.INFO.isSupported(rt);
    assert RCOP0.INFO.isSupported(cs);
    this.rt = rt;
    this.cs = cs;
  }

  @Override
  public String syntax(final PEState peState) {
    final PE pe__ = (PE) peState;
    return String.format("mfc0 %s, %s", rt.syntax(peState), cs.syntax(peState));
  }

  @Override
  public String image(final PEState peState) {
    final PE pe__ = (PE) peState;
    return String.format("01000000000%s%s00000000000", rt.image(peState), cs.image(peState));
  }

  @Override
  public void action(final PEState peState) {
    final PE pe__ = (PE) peState;
    rt.access(pe__).store(cs.access(pe__).load());
  }
}