/*
 * Copyright (c) Institute for System Programming of the Russian Academy of Sciences
 * All Rights Reserved
 *
 * Institute for System Programming of the Russian Academy of Sciences (ISP RAS)
 * 25 Alexander Solzhenitsyn st., Moscow, 109004, Russia
 * http://www.ispras.ru
 *
 * The present file was automatically generated on the basis of formal specifications.
 * It is distributed under the same terms and conditions as the derived specifications.
 *
 * N.B. PLEASE DO NOT MODIFY THIS FILE.
 */

package ru.ispras.microtesk.model.minimips.op;

import java.util.Map;
import java.math.BigInteger;
import ru.ispras.microtesk.model.api.ArgumentMode;
import ru.ispras.microtesk.model.api.Execution;
import ru.ispras.microtesk.model.api.PEState;
import ru.ispras.microtesk.model.api.data.*;
import ru.ispras.microtesk.model.api.memory.*;
import ru.ispras.microtesk.model.api.instruction.*;
import ru.ispras.microtesk.model.minimips.PE;
import ru.ispras.microtesk.model.minimips.mode.*;

import static ru.ispras.microtesk.model.minimips.TypeDefs.*;

public final class mtlo extends Operation {
  private static final class Info extends InfoAndRule {
    Info() {
      super(
         mtlo.class,
         "mtlo",
         new ArgumentDecls()
             .add("rs", REG.INFO),
         new Shortcuts()
             .addShortcut(new Info_instruction(), "#root")
      );
    }

    @Override
    public Operation create(final Map<String, Primitive> args) {
      final REG rs = (REG) getArgument("rs", args);

      return new mtlo(rs);
    }
  }
  private static final class Info_instruction extends InfoAndRule {
    Info_instruction() {
      super(
          instruction.class,
          "mtlo",
          new ArgumentDecls()
              .add("rs", REG.INFO)
      );
    }

    @Override
    public Operation create(final Map<String, Primitive> args) {
      final REG rs = (REG) getArgument("rs", args);

      return new instruction(
        new mtlo(
          rs
        )
      );
    }
  }
  public static final IInfo INFO = new Info();

  public final REG rs;

  public mtlo(final REG rs) {
    assert REG.INFO.isSupported(rs);
    this.rs = rs;
  }

  @Override
  public String syntax(final PEState peState) {
    final PE pe__ = (PE) peState;
    return String.format("mtlo %s", rs.syntax(peState));
  }

  @Override
  public String image(final PEState peState) {
    final PE pe__ = (PE) peState;
    return String.format("0000000000000000%s00000010010", rs.image(peState));
  }

  @Override
  public void action(final PEState peState) {
    final PE pe__ = (PE) peState;
    pe__.LO.access(0).store(rs.access(pe__).load());
  }
}