/*
 * Copyright (c) Institute for System Programming of the Russian Academy of Sciences
 * All Rights Reserved
 *
 * Institute for System Programming of the Russian Academy of Sciences (ISP RAS)
 * 25 Alexander Solzhenitsyn st., Moscow, 109004, Russia
 * http://www.ispras.ru
 *
 * The present file was automatically generated on the basis of formal specifications.
 * It is distributed under the same terms and conditions as the derived specifications.
 *
 * N.B. PLEASE DO NOT MODIFY THIS FILE.
 */

package ru.ispras.microtesk.model.minimips.op;

import java.util.Map;
import java.math.BigInteger;
import ru.ispras.microtesk.model.api.ArgumentMode;
import ru.ispras.microtesk.model.api.Execution;
import ru.ispras.microtesk.model.api.PEState;
import ru.ispras.microtesk.model.api.data.*;
import ru.ispras.microtesk.model.api.memory.*;
import ru.ispras.microtesk.model.api.instruction.*;
import ru.ispras.microtesk.model.minimips.PE;
import ru.ispras.microtesk.model.minimips.mode.*;
import ru.ispras.microtesk.model.api.memory.Location;

import static ru.ispras.microtesk.model.minimips.TypeDefs.*;

public final class sra extends Operation {
  private static final class Info extends InfoAndRule {
    Info() {
      super(
         sra.class,
         "sra",
         new ArgumentDecls()
             .add("rd", REG.INFO)
             .add("rt", REG.INFO)
             .add("sa", Type.CARD(5)),
         new Shortcuts()
             .addShortcut(new Info_instruction(), "#root")
      );
    }

    @Override
    public Operation create(final Map<String, Primitive> args) {
      final REG rd = (REG) getArgument("rd", args);
      final REG rt = (REG) getArgument("rt", args);
      final Immediate sa = (Immediate) getArgument("sa", args);

      return new sra(rd, rt, sa);
    }
  }
  private static final class Info_instruction extends InfoAndRule {
    Info_instruction() {
      super(
          instruction.class,
          "sra",
          new ArgumentDecls()
              .add("rd", REG.INFO)
              .add("rt", REG.INFO)
              .add("sa", Type.CARD(5))
      );
    }

    @Override
    public Operation create(final Map<String, Primitive> args) {
      final REG rd = (REG) getArgument("rd", args);
      final REG rt = (REG) getArgument("rt", args);
      final Immediate sa = (Immediate) getArgument("sa", args);

      return new instruction(
        new sra(
          rd,
          rt,
          sa
        )
      );
    }
  }
  public static final IInfo INFO = new Info();

  public final REG rd;
  public final REG rt;
  public final Immediate sa;

  public sra(final REG rd, final REG rt, final Immediate sa) {
    assert REG.INFO.isSupported(rd);
    assert REG.INFO.isSupported(rt);
    assert Type.CARD(5).equals(sa.getType());
    this.rd = rd;
    this.rt = rt;
    this.sa = sa;
  }

  @Override
  public String syntax(final PEState peState) {
    final PE pe__ = (PE) peState;
    return String.format("sra %s, %s, %d", rd.syntax(peState), rt.syntax(peState), sa.access(pe__).load().bigIntegerValue());
  }

  @Override
  public String image(final PEState peState) {
    final PE pe__ = (PE) peState;
    return String.format("00000000000%s%s%s000011", rt.image(peState), rd.image(peState), sa.access(pe__).load().toString());
  }

  @Override
  public void action(final PEState peState) {
    final PE pe__ = (PE) peState;
    rd.access(pe__).store(rt.access(pe__).load().shiftRight(sa.access(pe__).load()));
  }
}