/*
 * Copyright (c) Institute for System Programming of the Russian Academy of Sciences
 * All Rights Reserved
 *
 * Institute for System Programming of the Russian Academy of Sciences (ISP RAS)
 * 25 Alexander Solzhenitsyn st., Moscow, 109004, Russia
 * http://www.ispras.ru
 *
 * The present file was automatically generated on the basis of formal specifications.
 * It is distributed under the same terms and conditions as the derived specifications.
 *
 * N.B. PLEASE DO NOT MODIFY THIS FILE.
 */

package ru.ispras.microtesk.model.vliw;

import java.math.BigInteger;
import ru.ispras.microtesk.model.api.PEState;
import ru.ispras.microtesk.model.api.data.Type;
import ru.ispras.microtesk.model.api.memory.Label;
import ru.ispras.microtesk.model.api.memory.Memory;

/**
 * The {@code PE} class is automatically generated by MicroTESK.
 *
 * @author <a href="mailto:microtesk-support@ispras.ru">MicroTESK</a>
 */
public final class PE extends PEState {
  public final Memory GPR;
  public final Memory FPR;
  public final Memory M;
  public final Memory CIA;
  public final Memory FCCR;
  public final Memory NIA;
  public final Memory JMPADDR;
  public final Memory BRANCH;
  public final Memory temp;

  public PE() {
    this.GPR = Memory.def(Memory.Kind.REG, "GPR", TypeDefs.WORD, 0x20);
    this.FPR = Memory.def(Memory.Kind.REG, "FPR", TypeDefs.SINGLE, 0x20);
    this.M = Memory.def(Memory.Kind.MEM, "M", TypeDefs.BYTE, 0x80000000L);
    this.CIA = Memory.def(Memory.Kind.REG, "CIA", TypeDefs.WORD, 0x1);
    this.FCCR = Memory.def(Memory.Kind.REG, "FCCR", TypeDefs.WORD, 0x1);
    this.NIA = Memory.def(Memory.Kind.VAR, "NIA", TypeDefs.WORD, 0x1);
    this.JMPADDR = Memory.def(Memory.Kind.VAR, "JMPADDR", TypeDefs.WORD, 0x1);
    this.BRANCH = Memory.def(Memory.Kind.VAR, "BRANCH", TypeDefs.BIT, 0x1);
    this.temp = Memory.def(Memory.Kind.VAR, "temp", Type.CARD(33), 0x1);

    registerAll();
  }

  public PE(final PE other) {
    this.GPR = other.GPR;
    this.FPR = other.FPR;
    this.M = other.M;
    this.CIA = other.CIA;
    this.FCCR = other.FCCR;
    this.NIA = other.NIA;
    this.JMPADDR = other.JMPADDR;
    this.BRANCH = other.BRANCH;
    this.temp = other.temp;

    registerAll();
  }

  private void registerAll() {
    addStorage(GPR);
    addStorage(FPR);
    addStorage(M);
    addStorage(CIA);
    addStorage(FCCR);
    addStorage(NIA);
    addStorage(JMPADDR);
    addStorage(BRANCH);
    addStorage(temp);

    addLabel(new Label("PC", CIA, 0));
  }
}
