/*
 * Copyright (c) Institute for System Programming of the Russian Academy of Sciences
 * All Rights Reserved
 *
 * Institute for System Programming of the Russian Academy of Sciences (ISP RAS)
 * 25 Alexander Solzhenitsyn st., Moscow, 109004, Russia
 * http://www.ispras.ru
 *
 * The present file was automatically generated on the basis of formal specifications.
 * It is distributed under the same terms and conditions as the derived specifications.
 *
 * N.B. PLEASE DO NOT MODIFY THIS FILE.
 */

package ru.ispras.microtesk.model.vliw.op;

import java.util.Map;
import java.math.BigInteger;
import ru.ispras.microtesk.model.api.ArgumentMode;
import ru.ispras.microtesk.model.api.Execution;
import ru.ispras.microtesk.model.api.PEState;
import ru.ispras.microtesk.model.api.data.*;
import ru.ispras.microtesk.model.api.memory.*;
import ru.ispras.microtesk.model.api.instruction.*;
import ru.ispras.microtesk.model.vliw.PE;
import ru.ispras.microtesk.model.vliw.mode.*;
import ru.ispras.microtesk.model.api.memory.Location;

import static ru.ispras.microtesk.model.vliw.TypeDefs.*;

public final class ADDI extends Operation {
  private static final class Info extends InfoAndRule {
    Info() {
      super(
         ADDI.class,
         "ADDI",
         new ArgumentDecls()
             .add("rt", R.INFO)
             .add("rs", R.INFO)
             .add("imm", SHORT));
    }

    @Override
    public Operation create(final Map<String, Primitive> args) {
      final R rt = (R) getArgument("rt", args);
      final R rs = (R) getArgument("rs", args);
      final Immediate imm = (Immediate) getArgument("imm", args);

      return new ADDI(rt, rs, imm);
    }
  }
  public static final IInfo INFO = new Info();

  public final R rt;
  public final R rs;
  public final Immediate imm;

  public ADDI(final R rt, final R rs, final Immediate imm) {
    assert R.INFO.isSupported(rt);
    assert R.INFO.isSupported(rs);
    assert SHORT.equals(imm.getType());
    this.rt = rt;
    this.rs = rs;
    this.imm = imm;
  }

  @Override
  public String syntax(final PEState peState) {
    final PE pe__ = (PE) peState;
    return String.format("ADDI %s, %s, 0x%x", rt.syntax(peState), rs.syntax(peState), imm.access(pe__).load().bigIntegerValue(false));
  }

  @Override
  public String image(final PEState peState) {
    final PE pe__ = (PE) peState;
    return String.format("001000%s%s%s", rs.image(peState), rt.image(peState), imm.access(pe__).load().toString());
  }

  @Override
  public void action(final PEState peState) {
    final PE pe__ = (PE) peState;
    pe__.temp.access().store(Location.concat(rs.access(pe__), rs.access(pe__).bitField(31, 31)).load().add(Data.signExtend(Type.INT(33), imm.access(pe__).load())));
    if (!pe__.temp.access().bitField(32, 32).load().equals(pe__.temp.access().bitField(31, 31).load())) {
      Execution.exception("IntegerOverflow");
    } else {
      rt.access(pe__).store(pe__.temp.access().bitField(31, 0).load());
    }
  }
}