/*
 * Copyright (c) Institute for System Programming of the Russian Academy of Sciences
 * All Rights Reserved
 *
 * Institute for System Programming of the Russian Academy of Sciences (ISP RAS)
 * 25 Alexander Solzhenitsyn st., Moscow, 109004, Russia
 * http://www.ispras.ru
 *
 * The present file was automatically generated on the basis of formal specifications.
 * It is distributed under the same terms and conditions as the derived specifications.
 *
 * N.B. PLEASE DO NOT MODIFY THIS FILE.
 */

package ru.ispras.microtesk.model.vliw.op;

import java.util.Map;
import java.math.BigInteger;
import ru.ispras.microtesk.model.api.ArgumentMode;
import ru.ispras.microtesk.model.api.Execution;
import ru.ispras.microtesk.model.api.PEState;
import ru.ispras.microtesk.model.api.data.*;
import ru.ispras.microtesk.model.api.memory.*;
import ru.ispras.microtesk.model.api.instruction.*;
import ru.ispras.microtesk.model.vliw.PE;
import ru.ispras.microtesk.model.api.memory.Location;

import static ru.ispras.microtesk.model.vliw.TypeDefs.*;

public final class BFT extends Operation {
  private static final class Info extends InfoAndRule {
    Info() {
      super(
         BFT.class,
         "BFT",
         new ArgumentDecls()
             .add("cc", COND_CODE)
             .add("offset", SHORT));
    }

    @Override
    public Operation create(final Map<String, Primitive> args) {
      final Immediate cc = (Immediate) getArgument("cc", args);
      final Immediate offset = (Immediate) getArgument("offset", args);

      return new BFT(cc, offset);
    }
  }
  public static final IInfo INFO = new Info();

  public final Immediate cc;
  public final Immediate offset;

  public BFT(final Immediate cc, final Immediate offset) {
    assert COND_CODE.equals(cc.getType());
    assert SHORT.equals(offset.getType());
    this.cc = cc;
    this.offset = offset;
  }

  @Override
  public String syntax(final PEState peState) {
    final PE pe__ = (PE) peState;
    return String.format("BFT %d, <label>%d", cc.access(pe__).load().bigIntegerValue(), offset.access(pe__).load().bigIntegerValue());
  }

  @Override
  public String image(final PEState peState) {
    final PE pe__ = (PE) peState;
    return String.format("01000101000%s01%s", cc.access(pe__).load().toString(), offset.access(pe__).load().toString());
  }

  @Override
  public void action(final PEState peState) {
    final PE pe__ = (PE) peState;
    if (pe__.FCCR.access().bitField(cc.access(pe__).load(), cc.access(pe__).load()).load().equals(Data.valueOf(Type.INT(1), 0x1))) {
      pe__.BRANCH.access().store(Data.valueOf(BIT, 0x1));
      pe__.JMPADDR.access().store(pe__.NIA.access().load().add(Data.signExtend(WORD, offset.access(pe__).load()).shiftLeft(Data.valueOf(WORD, 0x3))));
    }
  }
}