/*
 * Copyright (c) Institute for System Programming of the Russian Academy of Sciences
 * All Rights Reserved
 *
 * Institute for System Programming of the Russian Academy of Sciences (ISP RAS)
 * 25 Alexander Solzhenitsyn st., Moscow, 109004, Russia
 * http://www.ispras.ru
 *
 * The present file was automatically generated on the basis of formal specifications.
 * It is distributed under the same terms and conditions as the derived specifications.
 *
 * N.B. PLEASE DO NOT MODIFY THIS FILE.
 */

package ru.ispras.microtesk.model.vliw.op;

import java.util.Map;
import java.math.BigInteger;
import ru.ispras.microtesk.model.api.ArgumentMode;
import ru.ispras.microtesk.model.api.Execution;
import ru.ispras.microtesk.model.api.PEState;
import ru.ispras.microtesk.model.api.data.*;
import ru.ispras.microtesk.model.api.memory.*;
import ru.ispras.microtesk.model.api.instruction.*;
import ru.ispras.microtesk.model.vliw.PE;
import ru.ispras.microtesk.model.vliw.mode.*;
import ru.ispras.microtesk.model.api.memory.Location;

import static ru.ispras.microtesk.model.vliw.TypeDefs.*;

public final class MOVT_S extends Operation {
  private static final class Info extends InfoAndRule {
    Info() {
      super(
         MOVT_S.class,
         "MOVT_S",
         new ArgumentDecls()
             .add("fd", F.INFO)
             .add("fs", F.INFO)
             .add("cc", COND_CODE));
    }

    @Override
    public Operation create(final Map<String, Primitive> args) {
      final F fd = (F) getArgument("fd", args);
      final F fs = (F) getArgument("fs", args);
      final Immediate cc = (Immediate) getArgument("cc", args);

      return new MOVT_S(fd, fs, cc);
    }
  }
  public static final IInfo INFO = new Info();

  public final F fd;
  public final F fs;
  public final Immediate cc;

  public MOVT_S(final F fd, final F fs, final Immediate cc) {
    assert F.INFO.isSupported(fd);
    assert F.INFO.isSupported(fs);
    assert COND_CODE.equals(cc.getType());
    this.fd = fd;
    this.fs = fs;
    this.cc = cc;
  }

  @Override
  public String syntax(final PEState peState) {
    final PE pe__ = (PE) peState;
    return String.format("MOVT_S %s, %s", fd.syntax(peState), fs.syntax(peState));
  }

  @Override
  public String image(final PEState peState) {
    final PE pe__ = (PE) peState;
    return String.format("01000110000%s01%s%s010001", cc.access(pe__).load().toString(), fs.image(peState), fd.image(peState));
  }

  @Override
  public void action(final PEState peState) {
    final PE pe__ = (PE) peState;
    if (pe__.FCCR.access().bitField(cc.access(pe__).load(), cc.access(pe__).load()).load().equals(Data.valueOf(Type.INT(1), 0x1))) {
      fd.access(pe__).store(fs.access(pe__).load());
    }
  }
}