/*
 * Copyright (c) Institute for System Programming of the Russian Academy of Sciences
 * All Rights Reserved
 *
 * Institute for System Programming of the Russian Academy of Sciences (ISP RAS)
 * 25 Alexander Solzhenitsyn st., Moscow, 109004, Russia
 * http://www.ispras.ru
 *
 * The present file was automatically generated on the basis of formal specifications.
 * It is distributed under the same terms and conditions as the derived specifications.
 *
 * N.B. PLEASE DO NOT MODIFY THIS FILE.
 */

package ru.ispras.microtesk.model.x86;

import java.math.BigInteger;
import ru.ispras.microtesk.model.api.PEState;
import ru.ispras.microtesk.model.api.data.Type;
import ru.ispras.microtesk.model.api.memory.Label;
import ru.ispras.microtesk.model.api.memory.Memory;

/**
 * The {@code PE} class is automatically generated by MicroTESK.
 *
 * @author <a href="mailto:microtesk-support@ispras.ru">MicroTESK</a>
 */
public final class PE extends PEState {
  public final Memory program_counter;
  public final Memory GPR;
  public final Memory AX;
  public final Memory AL;
  public final Memory AH;
  public final Memory CX;
  public final Memory CL;
  public final Memory CH;
  public final Memory DX;
  public final Memory DL;
  public final Memory DH;
  public final Memory BX;
  public final Memory BL;
  public final Memory BH;
  public final Memory SP;
  public final Memory BP;
  public final Memory SI;
  public final Memory DI;
  public final Memory RSEG;
  public final Memory ES;
  public final Memory CS;
  public final Memory SS;
  public final Memory DS;
  public final Memory IP;
  public final Memory FLAGS;
  public final Memory CF;
  public final Memory PF;
  public final Memory AF;
  public final Memory ZF;
  public final Memory SF;
  public final Memory TF;
  public final Memory IF;
  public final Memory DF;
  public final Memory OF;
  public final Memory M;
  public final Memory rm;
  public final Memory mod;
  public final Memory instr_size;
  public final Memory base;
  public final Memory tmpdw_op1;
  public final Memory tmpdw_op2;
  public final Memory tmpb_op1;
  public final Memory tmpb_op2;
  public final Memory tmpb_res;
  public final Memory tmpw_op1;
  public final Memory tmpw_op2;
  public final Memory tmpw_res;

  public PE() {
    this.program_counter = Memory.def(Memory.Kind.VAR, "program_counter", TypeDefs.ADDR, 0x1);
    this.GPR = Memory.def(Memory.Kind.REG, "GPR", TypeDefs.WORD, 0x8);
    this.AX = Memory.def(Memory.Kind.REG, "AX", TypeDefs.WORD, 0x1, GPR.access(0));
    this.AL = Memory.def(Memory.Kind.REG, "AL", TypeDefs.BYTE, 0x1, AX.access().bitField(0, 7));
    this.AH = Memory.def(Memory.Kind.REG, "AH", TypeDefs.BYTE, 0x1, AX.access().bitField(8, 15));
    this.CX = Memory.def(Memory.Kind.REG, "CX", TypeDefs.WORD, 0x1, GPR.access(1));
    this.CL = Memory.def(Memory.Kind.REG, "CL", TypeDefs.BYTE, 0x1, CX.access().bitField(0, 7));
    this.CH = Memory.def(Memory.Kind.REG, "CH", TypeDefs.BYTE, 0x1, CX.access().bitField(8, 15));
    this.DX = Memory.def(Memory.Kind.REG, "DX", TypeDefs.WORD, 0x1, GPR.access(2));
    this.DL = Memory.def(Memory.Kind.REG, "DL", TypeDefs.BYTE, 0x1, DX.access().bitField(0, 7));
    this.DH = Memory.def(Memory.Kind.REG, "DH", TypeDefs.BYTE, 0x1, DX.access().bitField(8, 15));
    this.BX = Memory.def(Memory.Kind.REG, "BX", TypeDefs.WORD, 0x1, GPR.access(3));
    this.BL = Memory.def(Memory.Kind.REG, "BL", TypeDefs.BYTE, 0x1, BX.access().bitField(0, 7));
    this.BH = Memory.def(Memory.Kind.REG, "BH", TypeDefs.BYTE, 0x1, BX.access().bitField(8, 15));
    this.SP = Memory.def(Memory.Kind.REG, "SP", TypeDefs.WORD, 0x1, GPR.access(4));
    this.BP = Memory.def(Memory.Kind.REG, "BP", TypeDefs.WORD, 0x1, GPR.access(5));
    this.SI = Memory.def(Memory.Kind.REG, "SI", TypeDefs.WORD, 0x1, GPR.access(6));
    this.DI = Memory.def(Memory.Kind.REG, "DI", TypeDefs.WORD, 0x1, GPR.access(7));
    this.RSEG = Memory.def(Memory.Kind.REG, "RSEG", TypeDefs.WORD, 0x4);
    this.ES = Memory.def(Memory.Kind.REG, "ES", TypeDefs.WORD, 0x1, RSEG.access(0));
    this.CS = Memory.def(Memory.Kind.REG, "CS", TypeDefs.WORD, 0x1, RSEG.access(1));
    this.SS = Memory.def(Memory.Kind.REG, "SS", TypeDefs.WORD, 0x1, RSEG.access(2));
    this.DS = Memory.def(Memory.Kind.REG, "DS", TypeDefs.WORD, 0x1, RSEG.access(3));
    this.IP = Memory.def(Memory.Kind.REG, "IP", TypeDefs.WORD, 0x1);
    this.FLAGS = Memory.def(Memory.Kind.REG, "FLAGS", TypeDefs.WORD, 0x1);
    this.CF = Memory.def(Memory.Kind.VAR, "CF", TypeDefs.BIT, 0x1, FLAGS.access().bitField(0, 0));
    this.PF = Memory.def(Memory.Kind.VAR, "PF", TypeDefs.BIT, 0x1, FLAGS.access().bitField(2, 2));
    this.AF = Memory.def(Memory.Kind.VAR, "AF", TypeDefs.BIT, 0x1, FLAGS.access().bitField(4, 4));
    this.ZF = Memory.def(Memory.Kind.VAR, "ZF", TypeDefs.BIT, 0x1, FLAGS.access().bitField(6, 6));
    this.SF = Memory.def(Memory.Kind.VAR, "SF", TypeDefs.BIT, 0x1, FLAGS.access().bitField(7, 7));
    this.TF = Memory.def(Memory.Kind.VAR, "TF", TypeDefs.BIT, 0x1, FLAGS.access().bitField(8, 8));
    this.IF = Memory.def(Memory.Kind.VAR, "IF", TypeDefs.BIT, 0x1, FLAGS.access().bitField(9, 9));
    this.DF = Memory.def(Memory.Kind.VAR, "DF", TypeDefs.BIT, 0x1, FLAGS.access().bitField(10, 10));
    this.OF = Memory.def(Memory.Kind.VAR, "OF", TypeDefs.BIT, 0x1, FLAGS.access().bitField(11, 11));
    this.M = Memory.def(Memory.Kind.MEM, "M", TypeDefs.BYTE, 0x100000);
    this.rm = Memory.def(Memory.Kind.VAR, "rm", Type.CARD(3), 0x1);
    this.mod = Memory.def(Memory.Kind.VAR, "mod", Type.CARD(2), 0x1);
    this.instr_size = Memory.def(Memory.Kind.VAR, "instr_size", TypeDefs.SIZE, 0x1);
    this.base = Memory.def(Memory.Kind.VAR, "base", TypeDefs.ADDR, 0x1);
    this.tmpdw_op1 = Memory.def(Memory.Kind.VAR, "tmpdw_op1", TypeDefs.DWORD, 0x1);
    this.tmpdw_op2 = Memory.def(Memory.Kind.VAR, "tmpdw_op2", TypeDefs.DWORD, 0x1);
    this.tmpb_op1 = Memory.def(Memory.Kind.VAR, "tmpb_op1", TypeDefs.BYTE, 0x1);
    this.tmpb_op2 = Memory.def(Memory.Kind.VAR, "tmpb_op2", TypeDefs.BYTE, 0x1);
    this.tmpb_res = Memory.def(Memory.Kind.VAR, "tmpb_res", Type.CARD(9), 0x1);
    this.tmpw_op1 = Memory.def(Memory.Kind.VAR, "tmpw_op1", TypeDefs.WORD, 0x1);
    this.tmpw_op2 = Memory.def(Memory.Kind.VAR, "tmpw_op2", TypeDefs.WORD, 0x1);
    this.tmpw_res = Memory.def(Memory.Kind.VAR, "tmpw_res", Type.CARD(17), 0x1);

    registerAll();
  }

  public PE(final PE other) {
    this.program_counter = other.program_counter;
    this.GPR = other.GPR;
    this.AX = other.AX;
    this.AL = other.AL;
    this.AH = other.AH;
    this.CX = other.CX;
    this.CL = other.CL;
    this.CH = other.CH;
    this.DX = other.DX;
    this.DL = other.DL;
    this.DH = other.DH;
    this.BX = other.BX;
    this.BL = other.BL;
    this.BH = other.BH;
    this.SP = other.SP;
    this.BP = other.BP;
    this.SI = other.SI;
    this.DI = other.DI;
    this.RSEG = other.RSEG;
    this.ES = other.ES;
    this.CS = other.CS;
    this.SS = other.SS;
    this.DS = other.DS;
    this.IP = other.IP;
    this.FLAGS = other.FLAGS;
    this.CF = other.CF;
    this.PF = other.PF;
    this.AF = other.AF;
    this.ZF = other.ZF;
    this.SF = other.SF;
    this.TF = other.TF;
    this.IF = other.IF;
    this.DF = other.DF;
    this.OF = other.OF;
    this.M = other.M;
    this.rm = other.rm;
    this.mod = other.mod;
    this.instr_size = other.instr_size;
    this.base = other.base;
    this.tmpdw_op1 = other.tmpdw_op1;
    this.tmpdw_op2 = other.tmpdw_op2;
    this.tmpb_op1 = other.tmpb_op1;
    this.tmpb_op2 = other.tmpb_op2;
    this.tmpb_res = other.tmpb_res;
    this.tmpw_op1 = other.tmpw_op1;
    this.tmpw_op2 = other.tmpw_op2;
    this.tmpw_res = other.tmpw_res;

    registerAll();
  }

  private void registerAll() {
    addStorage(program_counter);
    addStorage(GPR);
    addStorage(AX);
    addStorage(AL);
    addStorage(AH);
    addStorage(CX);
    addStorage(CL);
    addStorage(CH);
    addStorage(DX);
    addStorage(DL);
    addStorage(DH);
    addStorage(BX);
    addStorage(BL);
    addStorage(BH);
    addStorage(SP);
    addStorage(BP);
    addStorage(SI);
    addStorage(DI);
    addStorage(RSEG);
    addStorage(ES);
    addStorage(CS);
    addStorage(SS);
    addStorage(DS);
    addStorage(IP);
    addStorage(FLAGS);
    addStorage(CF);
    addStorage(PF);
    addStorage(AF);
    addStorage(ZF);
    addStorage(SF);
    addStorage(TF);
    addStorage(IF);
    addStorage(DF);
    addStorage(OF);
    addStorage(M);
    addStorage(rm);
    addStorage(mod);
    addStorage(instr_size);
    addStorage(base);
    addStorage(tmpdw_op1);
    addStorage(tmpdw_op2);
    addStorage(tmpb_op1);
    addStorage(tmpb_op2);
    addStorage(tmpb_res);
    addStorage(tmpw_op1);
    addStorage(tmpw_op2);
    addStorage(tmpw_res);

    addLabel(new Label("PC", program_counter, 0));
  }
}
