/*
 * Copyright (c) Institute for System Programming of the Russian Academy of Sciences
 * All Rights Reserved
 *
 * Institute for System Programming of the Russian Academy of Sciences (ISP RAS)
 * 25 Alexander Solzhenitsyn st., Moscow, 109004, Russia
 * http://www.ispras.ru
 *
 * The present file was automatically generated on the basis of formal specifications.
 * It is distributed under the same terms and conditions as the derived specifications.
 *
 * N.B. PLEASE DO NOT MODIFY THIS FILE.
 */

package ru.ispras.microtesk.model.x86.mode;

import java.util.Map;
import java.math.BigInteger;
import ru.ispras.microtesk.model.api.Execution;
import ru.ispras.microtesk.model.api.PEState;
import ru.ispras.microtesk.model.api.data.*;
import ru.ispras.microtesk.model.api.instruction.*;
import ru.ispras.microtesk.model.api.memory.Location;
import ru.ispras.microtesk.model.x86.PE;

import static ru.ispras.microtesk.model.x86.TypeDefs.*;

public final class GPR16 extends AddressingMode {
  public static final String NAME = "GPR16";

  private static final class Info extends InfoAndRule {
    Info() {
      super(
          GPR16.class,
          "GPR16",
          WORD,
          new ArgumentDecls()
              .add("i", INDEX)
      );
    }

    @Override
    public AddressingMode create(final Map<String, Primitive> args) {
      final Immediate i = (Immediate) getArgument("i", args);
      return new GPR16(i);
    }
  }

  public static final IInfo INFO = new Info();

  public final Immediate i;

  public GPR16(final Immediate i) {
    this.i = i;
  }

  @Override
  public String syntax(final PEState peState) {
    final PE pe__ = (PE) peState;
    return String.format("%s", i.access(pe__).load().equals(Data.valueOf(INDEX, 0x0)) ? "AX" : i.access(pe__).load().equals(Data.valueOf(INDEX, 0x1)) ? "CX" : i.access(pe__).load().equals(Data.valueOf(INDEX, 0x2)) ? "DX" : i.access(pe__).load().equals(Data.valueOf(INDEX, 0x3)) ? "BX" : i.access(pe__).load().equals(Data.valueOf(INDEX, 0x4)) ? "SP" : i.access(pe__).load().equals(Data.valueOf(INDEX, 0x5)) ? "BP" : i.access(pe__).load().equals(Data.valueOf(INDEX, 0x6)) ? "SI" : i.access(pe__).load().equals(Data.valueOf(INDEX, 0x7)) ? "DI" : "AX");
  }

  @Override
  public String image(final PEState peState) {
    final PE pe__ = (PE) peState;
    return String.format("%s", i.access(pe__).load().equals(Data.valueOf(INDEX, 0x0)) ? "000" : i.access(pe__).load().equals(Data.valueOf(INDEX, 0x1)) ? "001" : i.access(pe__).load().equals(Data.valueOf(INDEX, 0x2)) ? "010" : i.access(pe__).load().equals(Data.valueOf(INDEX, 0x3)) ? "011" : i.access(pe__).load().equals(Data.valueOf(INDEX, 0x4)) ? "100" : i.access(pe__).load().equals(Data.valueOf(INDEX, 0x5)) ? "101" : i.access(pe__).load().equals(Data.valueOf(INDEX, 0x6)) ? "110" : i.access(pe__).load().equals(Data.valueOf(INDEX, 0x7)) ? "111" : "000");
  }

  @Override
  public Location access(final PEState peState) {
    final PE pe__ = (PE) peState;
    return pe__.GPR.access(i.access(pe__).load()).setName(syntax(pe__));
  }
}