/*
 * Copyright (c) Institute for System Programming of the Russian Academy of Sciences
 * All Rights Reserved
 *
 * Institute for System Programming of the Russian Academy of Sciences (ISP RAS)
 * 25 Alexander Solzhenitsyn st., Moscow, 109004, Russia
 * http://www.ispras.ru
 *
 * The present file was automatically generated on the basis of formal specifications.
 * It is distributed under the same terms and conditions as the derived specifications.
 *
 * N.B. PLEASE DO NOT MODIFY THIS FILE.
 */

package ru.ispras.microtesk.model.x86.mode;

import java.util.Map;
import java.math.BigInteger;
import ru.ispras.microtesk.model.api.Execution;
import ru.ispras.microtesk.model.api.PEState;
import ru.ispras.microtesk.model.api.data.*;
import ru.ispras.microtesk.model.api.instruction.*;
import ru.ispras.microtesk.model.api.memory.Location;
import ru.ispras.microtesk.model.x86.PE;

import static ru.ispras.microtesk.model.x86.TypeDefs.*;

public final class R8 extends AddressingMode {
  public static final String NAME = "R8";

  private static final class Info extends InfoAndRule {
    Info() {
      super(
          R8.class,
          "R8",
          Type.CARD(8),
          new ArgumentDecls()
              .add("i", INDEX)
              .add("j", BIT)
      );
    }

    @Override
    public AddressingMode create(final Map<String, Primitive> args) {
      final Immediate i = (Immediate) getArgument("i", args);
      final Immediate j = (Immediate) getArgument("j", args);
      return new R8(i, j);
    }
  }

  public static final IInfo INFO = new Info();

  public final Immediate i;
  public final Immediate j;

  public R8(final Immediate i, final Immediate j) {
    this.i = i;
    this.j = j;
  }

  @Override
  public String syntax(final PEState peState) {
    final PE pe__ = (PE) peState;
    return String.format("%s", i.access(pe__).load().equals(Data.valueOf(INDEX, 0x0)) && j.access(pe__).load().equals(Data.valueOf(BIT, 0x0)) ? "AL" : i.access(pe__).load().equals(Data.valueOf(INDEX, 0x0)) && j.access(pe__).load().equals(Data.valueOf(BIT, 0x1)) ? "AH" : i.access(pe__).load().equals(Data.valueOf(INDEX, 0x1)) && j.access(pe__).load().equals(Data.valueOf(BIT, 0x0)) ? "CL" : i.access(pe__).load().equals(Data.valueOf(INDEX, 0x1)) && j.access(pe__).load().equals(Data.valueOf(BIT, 0x1)) ? "CH" : i.access(pe__).load().equals(Data.valueOf(INDEX, 0x2)) && j.access(pe__).load().equals(Data.valueOf(BIT, 0x0)) ? "DL" : i.access(pe__).load().equals(Data.valueOf(INDEX, 0x2)) && j.access(pe__).load().equals(Data.valueOf(BIT, 0x1)) ? "DH" : i.access(pe__).load().equals(Data.valueOf(INDEX, 0x3)) && j.access(pe__).load().equals(Data.valueOf(BIT, 0x0)) ? "BL" : i.access(pe__).load().equals(Data.valueOf(INDEX, 0x3)) && j.access(pe__).load().equals(Data.valueOf(BIT, 0x1)) ? "BH" : "AL");
  }

  @Override
  public String image(final PEState peState) {
    final PE pe__ = (PE) peState;
    return String.format("%s", i.access(pe__).load().equals(Data.valueOf(INDEX, 0x0)) && j.access(pe__).load().equals(Data.valueOf(BIT, 0x0)) ? "000" : i.access(pe__).load().equals(Data.valueOf(INDEX, 0x0)) && j.access(pe__).load().equals(Data.valueOf(BIT, 0x1)) ? "100" : i.access(pe__).load().equals(Data.valueOf(INDEX, 0x1)) && j.access(pe__).load().equals(Data.valueOf(BIT, 0x0)) ? "001" : i.access(pe__).load().equals(Data.valueOf(INDEX, 0x1)) && j.access(pe__).load().equals(Data.valueOf(BIT, 0x1)) ? "101" : i.access(pe__).load().equals(Data.valueOf(INDEX, 0x2)) && j.access(pe__).load().equals(Data.valueOf(BIT, 0x0)) ? "010" : i.access(pe__).load().equals(Data.valueOf(INDEX, 0x2)) && j.access(pe__).load().equals(Data.valueOf(BIT, 0x1)) ? "110" : i.access(pe__).load().equals(Data.valueOf(INDEX, 0x3)) && j.access(pe__).load().equals(Data.valueOf(BIT, 0x0)) ? "011" : i.access(pe__).load().equals(Data.valueOf(INDEX, 0x3)) && j.access(pe__).load().equals(Data.valueOf(BIT, 0x1)) ? "111" : "000");
  }

  @Override
  public Location access(final PEState peState) {
    final PE pe__ = (PE) peState;
    return new Location((j.access(pe__).load().equals(Data.valueOf(BIT, 0x0)) ? pe__.GPR.access(i.access(pe__).load()).bitField(0, 7).load() : pe__.GPR.access(i.access(pe__).load()).bitField(8, 15).load())).setName(syntax(pe__));
  }
}