/*
 * Copyright (c) Institute for System Programming of the Russian Academy of Sciences
 * All Rights Reserved
 *
 * Institute for System Programming of the Russian Academy of Sciences (ISP RAS)
 * 25 Alexander Solzhenitsyn st., Moscow, 109004, Russia
 * http://www.ispras.ru
 *
 * The present file was automatically generated on the basis of formal specifications.
 * It is distributed under the same terms and conditions as the derived specifications.
 *
 * N.B. PLEASE DO NOT MODIFY THIS FILE.
 */

package ru.ispras.microtesk.model.x86.op;

import java.util.Map;
import java.math.BigInteger;
import ru.ispras.microtesk.model.api.ArgumentMode;
import ru.ispras.microtesk.model.api.Execution;
import ru.ispras.microtesk.model.api.PEState;
import ru.ispras.microtesk.model.api.data.*;
import ru.ispras.microtesk.model.api.memory.*;
import ru.ispras.microtesk.model.api.instruction.*;
import ru.ispras.microtesk.model.x86.PE;
import ru.ispras.microtesk.model.x86.mode.*;

import static ru.ispras.microtesk.model.x86.TypeDefs.*;

public final class MOV_M8R8 extends Operation {
  private static final class Info extends InfoAndRule {
    Info() {
      super(
         MOV_M8R8.class,
         "MOV_M8R8",
         new ArgumentDecls()
             .add("seg_ovrd", RSEG16.INFO)
             .add("dst", MOFFS.INFO)
             .add("src", R8.INFO),
         new Shortcuts()
             .addShortcut(new Info_x86(), "#root")
      );
    }

    @Override
    public Operation create(final Map<String, Primitive> args) {
      final RSEG16 seg_ovrd = (RSEG16) getArgument("seg_ovrd", args);
      final AddressingMode dst = (AddressingMode) getArgument("dst", args);
      final R8 src = (R8) getArgument("src", args);

      return new MOV_M8R8(seg_ovrd, dst, src);
    }
  }
  private static final class Info_x86 extends InfoAndRule {
    Info_x86() {
      super(
          x86.class,
          "MOV_M8R8",
          new ArgumentDecls()
              .add("seg_ovrd", RSEG16.INFO)
              .add("dst", MOFFS.INFO)
              .add("src", R8.INFO)
      );
    }

    @Override
    public Operation create(final Map<String, Primitive> args) {
      final RSEG16 seg_ovrd = (RSEG16) getArgument("seg_ovrd", args);
      final AddressingMode dst = (AddressingMode) getArgument("dst", args);
      final R8 src = (R8) getArgument("src", args);

      return new x86(
        new MOV_M8R8(
          seg_ovrd,
          dst,
          src
        )
      );
    }
  }
  public static final IInfo INFO = new Info();

  public final RSEG16 seg_ovrd;
  public final AddressingMode dst;
  public final R8 src;

  public MOV_M8R8(final RSEG16 seg_ovrd, final AddressingMode dst, final R8 src) {
    assert RSEG16.INFO.isSupported(seg_ovrd);
    assert MOFFS.INFO.isSupported(dst);
    assert R8.INFO.isSupported(src);
    this.seg_ovrd = seg_ovrd;
    this.dst = dst;
    this.src = src;
  }

  @Override
  public String syntax(final PEState peState) {
    final PE pe__ = (PE) peState;
    return String.format("MOV %s:%s, %s", seg_ovrd.syntax(peState), dst.syntax(peState), src.syntax(peState));
  }

  @Override
  public String image(final PEState peState) {
    final PE pe__ = (PE) peState;
    return String.format("001%s11010001000%s%s%s%s", seg_ovrd.image(peState), pe__.mod.access().load().toString(), src.image(peState), pe__.rm.access().load().toString(), dst.image(peState));
  }

  @Override
  public void action(final PEState peState) {
    final PE pe__ = (PE) peState;
    pe__.base.access().store(Data.zeroExtend(ADDR, seg_ovrd.access(pe__).load()).shiftLeft(Data.valueOf(ADDR, 0x4)));
    pe__.M.access(pe__.base.access().load().add(dst.access(pe__).load())).store(src.access(pe__).load());
    dst.execute(pe__);
    pe__.instr_size.access().store(pe__.instr_size.access().load().add(Data.valueOf(SIZE, 0x3)));
  }
}