/*
 * Copyright (c) Institute for System Programming of the Russian Academy of Sciences
 * All Rights Reserved
 *
 * Institute for System Programming of the Russian Academy of Sciences (ISP RAS)
 * 25 Alexander Solzhenitsyn st., Moscow, 109004, Russia
 * http://www.ispras.ru
 *
 * The present file was automatically generated on the basis of formal specifications.
 * It is distributed under the same terms and conditions as the derived specifications.
 *
 * N.B. PLEASE DO NOT MODIFY THIS FILE.
 */

package ru.ispras.microtesk.model.x86.op;

import java.util.Map;
import java.math.BigInteger;
import ru.ispras.microtesk.model.api.ArgumentMode;
import ru.ispras.microtesk.model.api.Execution;
import ru.ispras.microtesk.model.api.PEState;
import ru.ispras.microtesk.model.api.data.*;
import ru.ispras.microtesk.model.api.memory.*;
import ru.ispras.microtesk.model.api.instruction.*;
import ru.ispras.microtesk.model.x86.PE;
import ru.ispras.microtesk.model.x86.mode.*;

import static ru.ispras.microtesk.model.x86.TypeDefs.*;

public final class NEG_R16 extends Operation {
  private static final class Info extends InfoAndRule {
    Info() {
      super(
         NEG_R16.class,
         "NEG_R16",
         new ArgumentDecls()
             .add("op1", GPR16.INFO),
         new Shortcuts()
             .addShortcut(new Info_x86(), "#root")
      );
    }

    @Override
    public Operation create(final Map<String, Primitive> args) {
      final GPR16 op1 = (GPR16) getArgument("op1", args);

      return new NEG_R16(op1);
    }
  }
  private static final class Info_x86 extends InfoAndRule {
    Info_x86() {
      super(
          x86.class,
          "NEG_R16",
          new ArgumentDecls()
              .add("op1", GPR16.INFO)
      );
    }

    @Override
    public Operation create(final Map<String, Primitive> args) {
      final GPR16 op1 = (GPR16) getArgument("op1", args);

      return new x86(
        new NEG_R16(
          op1
        )
      );
    }
  }
  public static final IInfo INFO = new Info();

  public final GPR16 op1;

  public NEG_R16(final GPR16 op1) {
    assert GPR16.INFO.isSupported(op1);
    this.op1 = op1;
  }

  @Override
  public String syntax(final PEState peState) {
    final PE pe__ = (PE) peState;
    return String.format("NEG %s", op1.syntax(peState));
  }

  @Override
  public String image(final PEState peState) {
    final PE pe__ = (PE) peState;
    return String.format("1111011111000%s", op1.image(peState));
  }

  @Override
  public void action(final PEState peState) {
    final PE pe__ = (PE) peState;
    new neg_proc_word(new Immediate(op1.access(pe__).load().add(Data.valueOf(WORD, 0x0)))).execute(pe__);
    op1.access(pe__).store(pe__.tmpw_res.access().bitField(0, 15).load());
    pe__.instr_size.access().store(pe__.instr_size.access().load().add(Data.valueOf(SIZE, 0x2)));
  }
}