/*
 * Copyright (c) Institute for System Programming of the Russian Academy of Sciences
 * All Rights Reserved
 *
 * Institute for System Programming of the Russian Academy of Sciences (ISP RAS)
 * 25 Alexander Solzhenitsyn st., Moscow, 109004, Russia
 * http://www.ispras.ru
 *
 * The present file was automatically generated on the basis of formal specifications.
 * It is distributed under the same terms and conditions as the derived specifications.
 *
 * N.B. PLEASE DO NOT MODIFY THIS FILE.
 */

package ru.ispras.microtesk.model.x86.op;

import java.util.Map;
import java.math.BigInteger;
import ru.ispras.microtesk.model.api.ArgumentMode;
import ru.ispras.microtesk.model.api.Execution;
import ru.ispras.microtesk.model.api.PEState;
import ru.ispras.microtesk.model.api.data.*;
import ru.ispras.microtesk.model.api.memory.*;
import ru.ispras.microtesk.model.api.instruction.*;
import ru.ispras.microtesk.model.x86.PE;
import ru.ispras.microtesk.model.x86.mode.*;

import static ru.ispras.microtesk.model.x86.TypeDefs.*;

public final class SBB_M8IMM8 extends Operation {
  private static final class Info extends InfoAndRule {
    Info() {
      super(
         SBB_M8IMM8.class,
         "SBB_M8IMM8",
         new ArgumentDecls()
             .add("seg_ovrd", RSEG16.INFO)
             .add("op1", MOFFS.INFO)
             .add("op2", IMM8.INFO),
         new Shortcuts()
             .addShortcut(new Info_x86(), "#root")
      );
    }

    @Override
    public Operation create(final Map<String, Primitive> args) {
      final RSEG16 seg_ovrd = (RSEG16) getArgument("seg_ovrd", args);
      final AddressingMode op1 = (AddressingMode) getArgument("op1", args);
      final IMM8 op2 = (IMM8) getArgument("op2", args);

      return new SBB_M8IMM8(seg_ovrd, op1, op2);
    }
  }
  private static final class Info_x86 extends InfoAndRule {
    Info_x86() {
      super(
          x86.class,
          "SBB_M8IMM8",
          new ArgumentDecls()
              .add("seg_ovrd", RSEG16.INFO)
              .add("op1", MOFFS.INFO)
              .add("op2", IMM8.INFO)
      );
    }

    @Override
    public Operation create(final Map<String, Primitive> args) {
      final RSEG16 seg_ovrd = (RSEG16) getArgument("seg_ovrd", args);
      final AddressingMode op1 = (AddressingMode) getArgument("op1", args);
      final IMM8 op2 = (IMM8) getArgument("op2", args);

      return new x86(
        new SBB_M8IMM8(
          seg_ovrd,
          op1,
          op2
        )
      );
    }
  }
  public static final IInfo INFO = new Info();

  public final RSEG16 seg_ovrd;
  public final AddressingMode op1;
  public final IMM8 op2;

  public SBB_M8IMM8(final RSEG16 seg_ovrd, final AddressingMode op1, final IMM8 op2) {
    assert RSEG16.INFO.isSupported(seg_ovrd);
    assert MOFFS.INFO.isSupported(op1);
    assert IMM8.INFO.isSupported(op2);
    this.seg_ovrd = seg_ovrd;
    this.op1 = op1;
    this.op2 = op2;
  }

  @Override
  public String syntax(final PEState peState) {
    final PE pe__ = (PE) peState;
    return String.format("SBB %s:%s, %s", seg_ovrd.syntax(peState), op1.syntax(peState), op2.syntax(peState));
  }

  @Override
  public String image(final PEState peState) {
    final PE pe__ = (PE) peState;
    return String.format("001%s11010000000%s000%s%s%s", seg_ovrd.image(peState), pe__.mod.access().load().toString(), pe__.rm.access().load().toString(), op1.image(peState), op2.image(peState));
  }

  @Override
  public void action(final PEState peState) {
    final PE pe__ = (PE) peState;
    pe__.base.access().store(Data.zeroExtend(ADDR, seg_ovrd.access(pe__).load()).shiftLeft(Data.valueOf(ADDR, 0x4)));
    new sub_proc_byte(new Immediate(pe__.M.access(pe__.base.access().load().add(op1.access(pe__).load()))), new Immediate(op2.access(pe__).load().subtract(Data.zeroExtend(BYTE, pe__.CF.access().load())))).execute(pe__);
    pe__.M.access(pe__.base.access().load().add(op1.access(pe__).load())).store(pe__.tmpb_res.access().bitField(0, 7).load());
    op1.execute(pe__);
    pe__.instr_size.access().store(pe__.instr_size.access().load().add(Data.valueOf(SIZE, 0x4)));
  }
}