/*
 * Copyright (c) Institute for System Programming of the Russian Academy of Sciences
 * All Rights Reserved
 *
 * Institute for System Programming of the Russian Academy of Sciences (ISP RAS)
 * 25 Alexander Solzhenitsyn st., Moscow, 109004, Russia
 * http://www.ispras.ru
 *
 * The present file was automatically generated on the basis of formal specifications.
 * It is distributed under the same terms and conditions as the derived specifications.
 *
 * N.B. PLEASE DO NOT MODIFY THIS FILE.
 */

package ru.ispras.microtesk.model.x86.op;

import java.util.Map;
import java.math.BigInteger;
import ru.ispras.microtesk.model.api.ArgumentMode;
import ru.ispras.microtesk.model.api.Execution;
import ru.ispras.microtesk.model.api.PEState;
import ru.ispras.microtesk.model.api.data.*;
import ru.ispras.microtesk.model.api.memory.*;
import ru.ispras.microtesk.model.api.instruction.*;
import ru.ispras.microtesk.model.x86.PE;
import ru.ispras.microtesk.model.x86.mode.*;

import static ru.ispras.microtesk.model.x86.TypeDefs.*;

public final class SBB_R16M16 extends Operation {
  private static final class Info extends InfoAndRule {
    Info() {
      super(
         SBB_R16M16.class,
         "SBB_R16M16",
         new ArgumentDecls()
             .add("seg_ovrd", RSEG16.INFO)
             .add("op1", GPR16.INFO)
             .add("op2", MOFFS.INFO),
         new Shortcuts()
             .addShortcut(new Info_x86(), "#root")
      );
    }

    @Override
    public Operation create(final Map<String, Primitive> args) {
      final RSEG16 seg_ovrd = (RSEG16) getArgument("seg_ovrd", args);
      final GPR16 op1 = (GPR16) getArgument("op1", args);
      final AddressingMode op2 = (AddressingMode) getArgument("op2", args);

      return new SBB_R16M16(seg_ovrd, op1, op2);
    }
  }
  private static final class Info_x86 extends InfoAndRule {
    Info_x86() {
      super(
          x86.class,
          "SBB_R16M16",
          new ArgumentDecls()
              .add("seg_ovrd", RSEG16.INFO)
              .add("op1", GPR16.INFO)
              .add("op2", MOFFS.INFO)
      );
    }

    @Override
    public Operation create(final Map<String, Primitive> args) {
      final RSEG16 seg_ovrd = (RSEG16) getArgument("seg_ovrd", args);
      final GPR16 op1 = (GPR16) getArgument("op1", args);
      final AddressingMode op2 = (AddressingMode) getArgument("op2", args);

      return new x86(
        new SBB_R16M16(
          seg_ovrd,
          op1,
          op2
        )
      );
    }
  }
  public static final IInfo INFO = new Info();

  public final RSEG16 seg_ovrd;
  public final GPR16 op1;
  public final AddressingMode op2;

  public SBB_R16M16(final RSEG16 seg_ovrd, final GPR16 op1, final AddressingMode op2) {
    assert RSEG16.INFO.isSupported(seg_ovrd);
    assert GPR16.INFO.isSupported(op1);
    assert MOFFS.INFO.isSupported(op2);
    this.seg_ovrd = seg_ovrd;
    this.op1 = op1;
    this.op2 = op2;
  }

  @Override
  public String syntax(final PEState peState) {
    final PE pe__ = (PE) peState;
    return String.format("SBB %s, %s:%s", op1.syntax(peState), seg_ovrd.syntax(peState), op2.syntax(peState));
  }

  @Override
  public String image(final PEState peState) {
    final PE pe__ = (PE) peState;
    return String.format("001%s11000011011%s%s%s%s", seg_ovrd.image(peState), pe__.mod.access().load().toString(), op1.image(peState), pe__.rm.access().load().toString(), op2.image(peState));
  }

  @Override
  public void action(final PEState peState) {
    final PE pe__ = (PE) peState;
    pe__.base.access().store(Data.zeroExtend(ADDR, seg_ovrd.access(pe__).load()).shiftLeft(Data.valueOf(ADDR, 0x4)));
    new sub_proc_word(new Immediate(op1.access(pe__).load().subtract(Data.zeroExtend(WORD, pe__.CF.access().load()))), new Immediate(Location.concat(pe__.M.access(pe__.base.access().load().add(op2.access(pe__).load())), pe__.M.access(pe__.base.access().load().add(op2.access(pe__).load()).add(Data.valueOf(ADDR, 0x1)))))).execute(pe__);
    op1.access(pe__).store(pe__.tmpw_res.access().bitField(0, 15).load());
    op2.execute(pe__);
    pe__.instr_size.access().store(pe__.instr_size.access().load().add(Data.valueOf(SIZE, 0x3)));
  }
}