/*
 * Copyright (c) Institute for System Programming of the Russian Academy of Sciences
 * All Rights Reserved
 *
 * Institute for System Programming of the Russian Academy of Sciences (ISP RAS)
 * 25 Alexander Solzhenitsyn st., Moscow, 109004, Russia
 * http://www.ispras.ru
 *
 * The present file was automatically generated on the basis of formal specifications.
 * It is distributed under the same terms and conditions as the derived specifications.
 *
 * N.B. PLEASE DO NOT MODIFY THIS FILE.
 */

package ru.ispras.microtesk.model.x86.op;

import java.util.Map;
import java.math.BigInteger;
import ru.ispras.microtesk.model.api.ArgumentMode;
import ru.ispras.microtesk.model.api.Execution;
import ru.ispras.microtesk.model.api.PEState;
import ru.ispras.microtesk.model.api.data.*;
import ru.ispras.microtesk.model.api.memory.*;
import ru.ispras.microtesk.model.api.instruction.*;
import ru.ispras.microtesk.model.x86.PE;
import ru.ispras.microtesk.model.api.memory.Location;

import static ru.ispras.microtesk.model.x86.TypeDefs.*;

public final class test_proc_word extends Operation {
  private static final class Info extends InfoAndRule {
    Info() {
      super(
         test_proc_word.class,
         "test_proc_word",
         new ArgumentDecls()
             .add("op1", WORD)
             .add("op2", WORD));
    }

    @Override
    public Operation create(final Map<String, Primitive> args) {
      final Immediate op1 = (Immediate) getArgument("op1", args);
      final Immediate op2 = (Immediate) getArgument("op2", args);

      return new test_proc_word(op1, op2);
    }
  }
  public static final IInfo INFO = new Info();

  public final Immediate op1;
  public final Immediate op2;

  public test_proc_word(final Immediate op1, final Immediate op2) {
    assert WORD.equals(op1.getType());
    assert WORD.equals(op2.getType());
    this.op1 = op1;
    this.op2 = op2;
  }

  @Override
  public void action(final PEState peState) {
    final PE pe__ = (PE) peState;
    pe__.tmpw_res.access().store(Data.zeroExtend(Type.CARD(17), op1.access(pe__).load().and(op2.access(pe__).load())));
    pe__.CF.access().store(Data.valueOf(BIT, 0x0));
    pe__.OF.access().store(Data.valueOf(BIT, 0x0));
    pe__.SF.access().store(pe__.tmpw_res.access().bitField(15, 15).load());
    pe__.ZF.access().store(Data.valueOf(BIT, pe__.tmpw_res.access().bitField(0, 15).load().equals(Data.valueOf(Type.CARD(16), 0x0))));
  }
}